#pragma once

#include <glm\glm.hpp>

#define ANGLE_STEP 75.0f
#define ANGLE_BORDER 45.0f

class Camera
{
public:
	Camera(void);
	~Camera(void);

	glm::mat4 getViewMatrix(glm::vec3 positionHero, glm::vec3 positionLight);
	void switchSide();
	void update(float deltaT);
	glm::vec3 getPosition();
	void setDebugVector(glm::vec3 vector);
	void changeCameraAngle();
	void changeDebugMode();

private:
	float rotation;
	bool isLeft;
	bool isDebugMode;

	glm::vec3 position;
	glm::vec3 positionDebug;
	glm::vec3 vectorDebug;
};

