#include "KeyboardManager.h"

void KeyboardManager::init(Window *_window) 
{
	window = _window;
}

void KeyboardManager::keyboardInput(GLFWwindow *_window, int key, int scancode, int action, int mods) 
{
	if(key == GLFW_KEY_ENTER || key == GLFW_KEY_SPACE || key == GLFW_KEY_TAB)
	{
		if(action == GLFW_PRESS) lastPressedKey = key;
	} else {
		if(action == GLFW_PRESS) 
		{
			switch(key) {

			/*********  Playermovement *****************/
			case GLFW_KEY_W:
				vectorPlayer.z = -1.0f;
				w = true;
				break;
			case GLFW_KEY_Q:
				vectorPlayer.y = 1.0f;
				break;
			case GLFW_KEY_S:
				vectorPlayer.z = 1.0f;
				s = true;
				break;
			case GLFW_KEY_E:
				vectorPlayer.y = -1.0f;
				break;
			case GLFW_KEY_A:
				vectorPlayer.x = -1.0f;
				a = true;
				break;
			case GLFW_KEY_D:
				vectorPlayer.x = 1.0f;
				d = true;
				break;
			/****************** DebugCamMovement*********************/
			case GLFW_KEY_T:
				vectorDebugCam.z = -1.0f;
				break;
			case GLFW_KEY_R:
				vectorDebugCam.y = 1.0f;
				break;
			case GLFW_KEY_G:
				vectorDebugCam.z = 1.0f;
				break;
			case GLFW_KEY_Z:
				vectorDebugCam.y = -1.0f;
				break;
			case GLFW_KEY_F:
				vectorDebugCam.x = -1.0f;
				break;
			case GLFW_KEY_H:
				vectorDebugCam.x = 1.0f;
				break;
				/****************** DebugLightMovement*********************/
			case GLFW_KEY_I:
				vectorDebugLight.z = -1.0f;
				break;
			case GLFW_KEY_U:
				vectorDebugLight.y = 1.0f;
				break;
			case GLFW_KEY_K:
				vectorDebugLight.z = 1.0f;
				break;
			case GLFW_KEY_O:
				vectorDebugLight.y = -1.0f;
				break;
			case GLFW_KEY_J:
				vectorDebugLight.x = -1.0f;
				break;
			case GLFW_KEY_L:
				vectorDebugLight.x = 1.0f;
				break;
			default: break;
			}
		}else if(action == GLFW_RELEASE){
			switch(key) {
			case GLFW_KEY_W:
				vectorPlayer.z = -0.0f;
				w = false;
				break;
			case GLFW_KEY_Q:
				vectorPlayer.y = 0.0f;
				break;
			case GLFW_KEY_S:
				vectorPlayer.z = 0.0f;
				s = false;
				break;
			case GLFW_KEY_E:
				vectorPlayer.y = 0.0f;
				break;
			case GLFW_KEY_A:
				vectorPlayer.x = 0.0f;
				a = false;
				break;
			case GLFW_KEY_D:
				vectorPlayer.x = 0.0f;
				d = false;
				break;
			/****************** DebugCamMovement*********************/
			case GLFW_KEY_T:
				vectorDebugCam.z = 0.0f;
				break;
			case GLFW_KEY_R:
				vectorDebugCam.y = 0.0f;
				break;
			case GLFW_KEY_G:
				vectorDebugCam.z = 0.0f;
				break;
			case GLFW_KEY_Z:
				vectorDebugCam.y = 0.0f;
				break;
			case GLFW_KEY_F:
				vectorDebugCam.x = 0.0f;
				break;
			case GLFW_KEY_H:
				vectorDebugCam.x = 0.0f;
				break;
				/****************** DebugLightMovement*********************/
			case GLFW_KEY_I:
				vectorDebugLight.z = 0.0f;
				break;
			case GLFW_KEY_U:
				vectorDebugLight.y = 0.0f;
				break;
			case GLFW_KEY_K:
				vectorDebugLight.z = 0.0f;
				break;
			case GLFW_KEY_O:
				vectorDebugLight.y = 0.0f;
				break;
			case GLFW_KEY_J:
				vectorDebugLight.x = 0.0f;
				break;
			case GLFW_KEY_L:
				vectorDebugLight.x = 0.0f;
				break;
			case GLFW_KEY_F2:
				changedInformations = true;
				drawFrameTime = !drawFrameTime;
				break;
			case GLFW_KEY_F3:
				changedInformations = true;
				fillPolygon = !fillPolygon;
				break;
			case GLFW_KEY_F4:
				changedInformations = true;
				textureSampling = !textureSampling;
				break;
			case GLFW_KEY_F5:
				changedInformations = true;
				mipMapping++;
				std::cout << "status MipMap: " << mipMapping << std::endl; 
				if(mipMapping==3) mipMapping= 0;
				break;
			case GLFW_KEY_F8:
				changedInformations = true;
				viewFrustum = !viewFrustum;
				break;
			case GLFW_KEY_F9:
				changedInformations = true;
				transparency = !transparency;
				break;
			default: break;
			}
		}
		lastPressedKey = key;
	}
}

int KeyboardManager::getKey() 
{
	int key = lastPressedKey;
	lastPressedKey = 0;
	return key;
}

glm::vec3 KeyboardManager::getVectorPlayer()
{
	vectorPlayer = glm::vec3(0.0f);

	if(a) vectorPlayer.x -= 1.0;
	if(d) vectorPlayer.x += 1.0;
	if(w) vectorPlayer.z -= 1.0;
	if(s) vectorPlayer.z += 1.0;

	return vectorPlayer;
}

glm::vec3 KeyboardManager::getVectorDebugCam()
{
	return vectorDebugCam;
}

glm::vec3 KeyboardManager::getVectorDebugLight()
{
	return vectorDebugLight;
}

bool KeyboardManager::isViewFrustumEnabled(void) { return viewFrustum; }
bool KeyboardManager::isFillPolygonsEnabled(void) { return fillPolygon; }
bool KeyboardManager::isInvisabilityEnabled(void) { return transparency; }
bool KeyboardManager::isFrameTimeEnabled(void) { return drawFrameTime; }
bool KeyboardManager::isInformationRequired(void) { 
	if(changedInformations==true) {
		changedInformations = false;
		return true;
	} else return false;
}
bool KeyboardManager::isTextureSamplingLinear(void) { return textureSampling; }
int KeyboardManager::levelOfMipMapping(void) {return mipMapping;}

bool KeyboardManager::isInit = false;
bool KeyboardManager::w = false;
bool KeyboardManager::a = false;
bool KeyboardManager::s = false;
bool KeyboardManager::d = false;
bool KeyboardManager::viewFrustum = true;
bool KeyboardManager::fillPolygon = true;
bool KeyboardManager::drawFrameTime = false;
bool KeyboardManager::transparency = true;
bool KeyboardManager::changedInformations = false;
bool KeyboardManager::textureSampling = false;
int KeyboardManager::mipMapping = 0;
Window * KeyboardManager::window;
int KeyboardManager::lastPressedKey = 0;
glm::vec3 KeyboardManager::vectorPlayer = glm::vec3(0.0f);
glm::vec3 KeyboardManager::vectorDebugCam = glm::vec3(0.0f);
glm::vec3 KeyboardManager::vectorDebugLight = glm::vec3(0.0f);