#pragma once

#include <GL/glew.h>
#include <GLFW\glfw3.h>
#include <iostream>
#include <string>
#include <map>
#include "../Objects/Shader.h"

class ShaderManager
{
public:

	enum SHADER {
		BASICSHADER,
		DEPTHSHADER,
		FLAMESHADER,
		BLOOMSHADER,
		HUDSHADER
	};
	static ShaderManager* getInstance();
	GLint getUniformLoc(SHADER s, std::string name);
	GLuint getShaderProgramHandle(SHADER s);
	void useShader(SHADER s);
protected:
	ShaderManager();
private:
	std::map<std::string , GLint> listBasic, listDepth, listFlame, listBloom, listHud;
	Shader *shader, *depthShader, *flameShader, *bloomShader, *hudShader;

	static ShaderManager *_instance;
};

