#pragma once

#include <gl\glew.h>
#include <GLFW\glfw3.h>
#include <iostream>

// http://ogldev.atspace.co.uk/www/tutorial43/tutorial43.html
class ShadowMapping
{
public:
	ShadowMapping(void);
	~ShadowMapping(void);

	bool init(int width, int height);

	void BindForWriting();
	void UnBindForWriting();

	void BindForReadingTextureMap(GLenum TextureUnit);
	void BindForReadingTextureMapSmall(GLenum TextureUnit);
	void BindForReadingDepthMap(GLenum TextureUnit);

	void ClearColorWhite();
	void ClearColorTransparent();

	void PrepareForFlameMap(int i);
	void PrepareForShadowMap();

private:
	GLuint m_fbo, m_shadowMap, m_depth, m_renderedTexture, m_renderedTextureSmall;
};

