#include "CubeInvis.h"


CubeInvis::CubeInvis(glm::vec3 _position)
	: Cube(_position)
	,fadingSpeed(0.75f)
{
	isFading = false;
}


CubeInvis::~CubeInvis(void)
{

}

void CubeInvis::update(float deltaT) 
{
	int x =(int)(positionHero.x+0.2f);
	int z =(int)(positionHero.z+0.2f);

	if(x == position.x && z == position.z) {
		isFading = true;
	}

	if(isFading == true) 
	{
		visability -= fadingSpeed *deltaT;
		//std::cout<< "Visability: " << visability*100 << "%" << std::endl;
	}

	if(visability < 0.0f)
	{
		dead = true;
		isFading = false;
	}
	
	Cube::update(deltaT);
}

void CubeInvis::draw(RENDERTYPE mode, bool transparencyEnabled)
{
	if(mode == RENDERTYPE::DEPTHSHADER)
	{
		Cube::draw(mode);
	} else if(mode==RENDERTYPE::BASIC) 
	{
		Cube::draw(mode);
	} else if(mode==RENDERTYPE::TRANSPARENCY)
	{
		GLenum error = glGetError();
		if(error != GL_NO_ERROR) std::cout << "before Uniform transparency" << std::endl;
		if(transparencyEnabled) 
		{
			error = glGetError();
			if(error != GL_NO_ERROR) std::cout << "before " << std::endl;
			glUniform1f(shaderManager->getUniformLoc(ShaderManager::SHADER::BASICSHADER, "transparency"), visability);
			error = glGetError();
			if(error != GL_NO_ERROR) std::cout << "after" << std::endl;
		} else {
			error = glGetError();
			if(error != GL_NO_ERROR) std::cout << "before " << std::endl;
			glUniform1f(shaderManager->getUniformLoc(ShaderManager::SHADER::BASICSHADER, "transparency"), 1.0f);
			error = glGetError();
			if(error != GL_NO_ERROR) std::cout << "after" << std::endl;
		}
		error = glGetError();
		if(error != GL_NO_ERROR) std::cout << "after Uniform transparency" << std::endl;
		Cube::draw(mode);
	}
}
