#pragma once

#include <GL\glew.h>
#include <GLFW\glfw3.h>
#include <glm/glm.hpp>
#include <glm\gtx\vector_angle.hpp>
#include <glm/gtc/matrix_transform.hpp>

#include "../SceneObject.h"
#include "../Shader.h"

class Goodie :
	public SceneObject
{
public:
	enum GOODIE_STATE {
		LYING,
		COLLECTED,
		GONE
	};

	Goodie(glm::vec3 position);
	~Goodie(void);

	virtual void draw(RENDERTYPE mode);
	virtual void update(double floatT);
	virtual void updateModelMatrixAtChildren(glm::mat4 modelMat);
	int goodieCollected(glm::vec3 pos);

private:
	GOODIE_STATE state;
	float collectableDistance;
};

