#include "Propeller.h"

Propeller::Propeller(glm::vec3 _position)
	: SceneObject("propeller/propeller",_position,  4.0f, 0.25f)
{	
	material = new Material(0.2f, 1.0f, 0.1f); 
	rotation = 0.0f;
}

Propeller::~Propeller(void)
{
}

void Propeller::draw(RENDERTYPE mode)
{
	if(mode == RENDERTYPE::DEPTHSHADER) {
		//DepthShader
		glUniformMatrix4fv(shaderManager->getUniformLoc(ShaderManager::SHADER::DEPTHSHADER,"modelMatrix"), 1, 
			GL_FALSE, glm::value_ptr(modelMatrix));
		SceneObject::draw(mode);
	} else if(mode == RENDERTYPE::BASIC) {
		//BasicShader
		glUniformMatrix4fv(shaderManager->getUniformLoc(ShaderManager::SHADER::BASICSHADER, "modelMatrix"), 1, 
			GL_FALSE, glm::value_ptr(modelMatrix));
		SceneObject::draw(mode);
	} else if(mode == RENDERTYPE::FLAMESHADER) {
	} else if(mode == RENDERTYPE::BLOOMSHADER) {
	}
}

void Propeller::update(GLdouble deltaT)
{
	modelMatrix = glm::translate(position);
	
	rotation += TURN_RATE * deltaT;

	glm::mat4 rotateX = glm::rotate(-90.0f,glm::vec3(1.0f, 0.0f, 0.0f));
	glm::mat4 rotateZ = glm::rotate(rotation, glm::vec3(0.0f, 0.0f, 1.0f));

	modelMatrix = glm::scale(glm::vec3(scaleObject)) * glm::translate(glm::vec3(0.0f, 1.35f/scaleObject, -0.4f)) *rotateZ * rotateX;
}

void Propeller::update(glm::mat4 modelMat, GLdouble deltaT)
{
	update(deltaT);

	modelMatrix = modelMat * modelMatrix;
}

