#include "Bar.h"

Bar::Bar(glm::vec3 _position, glm::vec3 colorFinal)
	: SceneObject("bar/bar", _position, 1.0f, 3.0f)
	, colorFinal(colorFinal)
	, barLength(1.0f)
	, colorNeutral(0.8f, 0.8f, 0.8f)
{
}

Bar::~Bar(void)
{
}

void Bar::update(double deltaT)
{
	modelMatrix = glm::translate(glm::vec3(position)) * glm::scale(glm::vec3(barLength, 0.05f, 1.0f));
	//modelMatrix = glm::rotate(modelMatrix, 90.0f * (float)deltaT, glm::vec3(1.0f, 0.0f, 0.0f));
}

void Bar::draw(RENDERTYPE mode)
{
	
	if(mode == RENDERTYPE::HUDSHADER) {
		glUniformMatrix4fv(shaderManager->getUniformLoc(ShaderManager::SHADER::HUDSHADER, "modelMatrix"), 1, 
			GL_FALSE, glm::value_ptr(modelMatrix));

		glUniform3fv(shaderManager->getUniformLoc(ShaderManager::SHADER::HUDSHADER, "colorFinal"), 1,
				glm::value_ptr(colorFinal));

		glUniform3fv(shaderManager->getUniformLoc(ShaderManager::SHADER::HUDSHADER, "colorNeutral"), 1,
				glm::value_ptr(colorFinal));
		SceneObject::draw(mode);
	}
}

void Bar::updateParam(double value) {
	barLength = value;
}