#include "Plane.h"

Plane::Plane(glm::vec3 _position)
	: SceneObject("plane/plane", _position, 1.0f, 3.0f)
{
	//modelMatrix = glm::rotate(180.0f, glm::vec3(0.0f, 1.0f, 0.0f));
}

Plane::~Plane(void)
{
}

void Plane::update(double deltaT)
{
	modelMatrix = glm::scale(glm::vec3(0.5f)) * glm::rotate(modelMatrix, 90.0f * (float)deltaT, glm::vec3(1.0f, 0.0f, 0.0f));
}

void Plane::draw(RENDERTYPE mode)
{
	
	if(mode == RENDERTYPE::BLOOMSHADER) {
		glUniformMatrix4fv(shaderManager->getUniformLoc(ShaderManager::SHADER::BLOOMSHADER,"modelMatrix"), 1, 
			GL_FALSE, glm::value_ptr(modelMatrix));
		
		SceneObject::draw(mode);
	}
}
